<template>
    <b-table hover :items="limitedItems">
        <template v-slot:cell(note)="data">
            <span v-html="data.value"></span>
        </template>
        <template v-slot:custom-foot v-if="showExceedingItemsRow">
            <b-td colspan="5" class="text-center text-muted">
                And <b>+{{exceedingRowCount}}</b> more results
            </b-td>
        </template>
    </b-table>
</template>

<script>
export default {
    name: 'TableTestResults',
    props: {
        items: {
            type: Array,
            required: true
        },
        limit: {
            type: Number,
            default: 200
        },
        hidePhoneNumberCol: {
            type: Boolean,
            default: false
        }
    },
    computed: {
        rowsLimit() {
            return this.limit >= 0 ? this.limit : 200;
        },
        showExceedingItemsRow() {
            if (this.rowsLimit > 0) {
                return this.items.length > this.rowsLimit;
            }
            return false;
        },
        exceedingRowCount() {
            if (this.rowsLimit > 0) {
                const count = this.items.length - this.rowsLimit;
                return count > 0 ? count : 0;
            }
            return 0;
        },
        limitedItems() {
            /**
             * @type  {PhoneNumber[]}
             */
            let items = null;
            if (this.rowsLimit > 0) {
                items = this.items.length > this.rowsLimit ? this.items.slice(0, this.rowsLimit) : this.items;
            } else {
                items = this.items;
            }

            return items.map(
                (item) => {
                    const row = {
                        id: item.id,
                        provided_value: item.originalValue
                    }

                    if (this.hidePhoneNumberCol === false) {
                        row.phone_number = item.phoneNumber;
                    }
                        
                    row.is_valid = (() => {
                        return item.isSuccesful() ? 'VALID' : item.hasBeenCorrected() ? 'CORRECTED' : 'INVALID';
                    })();

                    if (item.isSuccesful()) {
                        row.note = '';
                        row._cellVariants = {
                            is_valid: 'success'
                        }
                    }
                    else if (item.hasBeenCorrected()) {
                        row.note = item.getCorrectionsText();
                        row._cellVariants = {
                            is_valid: 'warning'
                        }
                    } else if (item.isFailed()) {
                        row.note = item.error;
                        row._cellVariants = {
                            is_valid: 'danger'
                        }
                    }
                    return row;
                }
            )
        }
    }
}
</script>

<style>

</style>